package jsonrpc

// GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.

import (
	"github.com/AccumulateNetwork/jsonrpc2/v15"
	"gitlab.com/accumulatenetwork/core/wallet/pkg/wallet"
)

type GeneralServiceServer struct {
	Service wallet.GeneralService
}

func (s GeneralServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"Decode":           makeMethod(s.Service.Decode),
		"Encode":           makeMethod(s.Service.Encode),
		"GenerateMnemonic": makeMethod(s.Service.GenerateMnemonic),
		"RefreshToken":     makeMethod(s.Service.RefreshToken),
		"Version":          makeMethodNoInput(s.Service.Version),
	}
}

type VaultServiceServer struct {
	Service wallet.VaultService
}

func (s VaultServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"AdoptVault":         makeMethod(s.Service.AdoptVault),
		"ConvertWallet":      makeMethod(s.Service.ConvertWallet),
		"CopyVaultSanitized": makeMethod(s.Service.CopyVaultSanitized),
		"CreateVault":        makeMethod(s.Service.CreateVault),
		"CreateWallet":       makeMethod(s.Service.CreateWallet),
		"EncryptVault":       makeMethod(s.Service.EncryptVault),
		"ExportVault":        makeMethod(s.Service.ExportVault),
		"ImportMnemonic":     makeMethod(s.Service.ImportMnemonic),
		"ImportVault":        makeMethod(s.Service.ImportVault),
		"ListVaults":         makeMethod(s.Service.ListVaults),
		"LockVault":          makeMethod(s.Service.LockVault),
		"OpenVault":          makeMethod(s.Service.OpenVault),
		"Set1PasswordRef":    makeMethod(s.Service.Set1PasswordRef),
		"Status":             makeMethod(s.Service.Status),
		"UnlockVault":        makeMethod(s.Service.UnlockVault),
	}
}

type TransactionServiceServer struct {
	Service wallet.TransactionService
}

func (s TransactionServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"AddMemoToTransaction": makeMethod(s.Service.AddMemoToTransaction),
		"AddSendTokensOutput":  makeMethod(s.Service.AddSendTokensOutput),
		"CreateEnvelope":       makeMethod(s.Service.CreateEnvelope),
		"CreateTransaction":    makeMethod(s.Service.CreateTransaction),
		"DeleteTransaction":    makeMethod(s.Service.DeleteTransaction),
		"GetTransaction":       makeMethod(s.Service.GetTransaction),
		"ListTransactions":     makeMethod(s.Service.ListTransactions),
		"WriteDataTransaction": makeMethod(s.Service.WriteDataTransaction),
	}
}

type KeyServiceServer struct {
	Service wallet.KeyService
}

func (s KeyServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"FindSigner":         makeMethod(s.Service.FindSigner),
		"GenerateAddress":    makeMethod(s.Service.GenerateAddress),
		"ImportKey":          makeMethod(s.Service.ImportKey),
		"KeyAssign":          makeMethod(s.Service.KeyAssign),
		"KeyList":            makeMethod(s.Service.KeyList),
		"KeyRemove":          makeMethod(s.Service.KeyRemove),
		"KeyRename":          makeMethod(s.Service.KeyRename),
		"ResolveKey":         makeMethod(s.Service.ResolveKey),
		"RestoreKeyCounters": makeMethod(s.Service.RestoreKeyCounters),
	}
}

type LedgerServiceServer struct {
	Service wallet.LedgerService
}

func (s LedgerServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"LedgerGenerateKey":  makeMethod(s.Service.LedgerGenerateKey),
		"LedgerQueryWallets": makeMethodNoInput(s.Service.LedgerQueryWallets),
	}
}

type AccountServiceServer struct {
	Service wallet.AccountService
}

func (s AccountServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"AdiList":                makeMethod(s.Service.AdiList),
		"ListAccounts":           makeMethod(s.Service.ListAccounts),
		"RegisterADI":            makeMethod(s.Service.RegisterADI),
		"RegisterBook":           makeMethod(s.Service.RegisterBook),
		"RegisterTokenAccount":   makeMethod(s.Service.RegisterTokenAccount),
		"UnregisterBook":         makeMethod(s.Service.UnregisterBook),
		"UnregisterTokenAccount": makeMethod(s.Service.UnregisterTokenAccount),
	}
}

type SigningServiceServer struct {
	Service wallet.SigningService
}

func (s SigningServiceServer) methods() jsonrpc2.MethodMap {
	return jsonrpc2.MethodMap{
		"ResetLastUsedOn": makeMethod(s.Service.ResetLastUsedOn),
		"Sign":            makeMethod(s.Service.Sign),
		"SignMessage":     makeMethod(s.Service.SignMessage),
		"SignTransaction": makeMethod(s.Service.SignTransaction),
	}
}
